<?php
//http://api.funshion.com/ajax/vod_panel/317009
//http://api1.fun.tv/ajax/new_playinfo/gallery/1008237/?user=funshion&mid=317081

//http://pm.funshion.com/v5/media/play/?id=807608&cl=mweb&uc=30
 /*a_mobile_url = 'http://m.fun.tv/implay/?mid=302555'
    video_ep = 'http://pv.funshion.com/v7/video/play/?id={}&cl=mweb&uc=111'
    media_ep = 'http://pm.funshion.com/v7/media/play/?id={}&cl=mweb&uc=111'
*/


    //http://pv.funshion.com/v7/video/play/?id=18571251&cl=mweb&uc=111
define('MOZECNAME',implode("|",Funshion::mozEcName()));		
echo json_encode(Funtv::parse($url));

/**
* 
*/
class Funtv
{
	public static function parse($url)
	{
		$html = self::curl($url);
		preg_match('#data\-mid="(\d+)"\s*data\-vid="(\d+)"#iU',$html,$ids);
		$mid = $ids[1];
	    $vid = $ids[2];
		return self::get_video_play_info($vid);
	}
	public static function get_video_play_info($vid)
	{
		$api = "http://api1.fun.tv/ajax/new_playinfo/gallery/{$vid}/?user=funshion";
		$content = self::curl($api);
		$json = json_decode($content,true);
		if($json["status"]==200){
			$data = $json["data"];
			$playinfos = $data["playinfos"];
			$count = 0;
			$mozEcName = explode("|",MOZECNAME);;
			foreach ($playinfos as $key => $value) {
				$def = $value["clarity"];//tv流畅 dvd标清  hd高清  sdvd超清 shd超高清
				if($def=="shd"){//跳过超高清，超高清无效
					continue;
				}
				$defname = $value["name"];
				$hash = substr(Funshion::funshion_decrypt($mozEcName,$value["hashid"]),0,40);
				$mp4 = self::get_video_mp4($hash);
				$vf = $value["vf"];//检验码
				$token = base64_encode(Funshion::funshion_decrypt($mozEcName,$value["token"]));
				$mp4 .= "?token={$token}&vf={$vf}";
				if (GlobalBase::is_ipad()) {
					if($def=="hd"){
		    			$videoinfo["video"]["file"] = $mp4;
						$videoinfo["video"]["type"] = "video/mp4";
		    			break;
		    		}
			    }else{
			    	$video[0] = $mp4;
					$video[1] = "video/mp4";
					$video[2] = $defname;
					$video[3] = $def == "hd"? 10:0;
					$videoinfo["flashplayer"] = true;
					$videoinfo["video"][$count] = $video;
			    }
				$count++;
			}
			return $videoinfo;
		}
	}
	public static function get_video_mp4($hash)
	{
		$api = "http://jobsfe.funshion.com/query/v1/mp4/{$hash}.json";
		$content = self::curl($api);
		$json = json_decode($content,true);
		if($json["return"]=="succ"){
			$url = $json["playlist"][0]["urls"][0];
			return $url;
		}else{
			return null;
		}
		
	}
	public static function curl($url,$cookie="")
	{
    	$params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    	$params["cookie"] = $cookie;
      	return GlobalBase::curl($url,$params);
	}
}

/**
* 风行算法
*/
class Funshion
{
	public static function mozEcName()
	{
		$api = "http://m.fun.tv/implay/?".time();
		$html = GlobalBase::curl($api);
		preg_match_all('#src="(.*/[mcore|mtool].*.js)"#iU',$html,$jss);
		$mozEcName = array();
		foreach ($jss[1] as $key => $value) {
			$js = "http://m.fun.tv".$value."?".time();
			$content = JS::parse($js);
			preg_match_all('#mozEcName.push\("(.*)"\);#iU',$content,$code);
            $mozEcName  = count($mozEcName)==0?$code[1]:array_merge($mozEcName,$code[1]);
		}
		return $mozEcName;
	}
	public static function funshion_decrypt($mozEcName,$data)
	{
		if (strlen($data) == 28 && substr($data,-1) == '0'){
			$data = substr($data,0,27)."=";
			$n = self::e($data);
			$clear = self::o($mozEcName,$n);
			return self::hexlify($clear);
		}else{
			$data = substr($data,2);
 			$n = self::e($data);
			$clear = self::o($mozEcName,$n);
 			return $clear;
		}
	}
	public static function hexlify($data) {
	    $n = "";
	    $chars = str_split($data);
	    for ($e = 0, $i = strlen($data); $i > $e; $e++){
	    	$n .= dechex(ord($chars[$e]));
	    }
	    return $n;
	}
	public static function e($t) {
	  	$a = array(-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);
	  	$r = 0;
	  	$d = "";
	  	$chars = str_split($t);
        for ($s = count($chars); $s > $r;) {
            do{
            	$e = $a[255 & @ord($chars[$r++])]; 
            }while ($s > $r && -1 == $e);
            if (-1 == $e) break;
            do{
	            $i = $a[255 & @ord($chars[$r++])]; 
	        }while ($s > $r && -1 == $i);
	        if (-1 == $i) break;
            $d .= chr($e << 2 | (48 & $i) >> 4);
            do {
            	$o = 255 & @ord($chars[$r++]);
                if (61 == $o) return $d;
                $o = $a[$o];
            } while ($s > $r && -1 == $o);
            if (-1 == $o) break;
            $d .= chr((15 & $i) << 4 | (60 & $o) >> 2);
            do {
            	$n = 255 & @ord($chars[$r++]);
                if (61 == $n) return $d;
                $n = $a[$n];
            } while ($s > $r && -1 == $n);
            if (-1 == $n) break;
            $d .= chr((3 & $o) << 6 | $n);
        }
        return $d;
    }
    public static function o($mozEcName,$t) {
     	$chars = str_split($t);
     	$e = "";
        for ($i = 0; $i < count($chars);) {
            $o = ord($chars[$i++]);
            $r = ord($chars[$i++]);
            $e .= chr(self::nn($mozEcName,$o, $r)["z1"]);
            $e .= chr(self::nn($mozEcName,$o, $r)["z2"]);
            if ($i == count($chars)- 1) {
                $e .= chr(ord($chars[$i]));
                break;
            }
        }
        return $e;
    }
    public static function nn($mozEcName,$t, $e) {
        $n = array();
        for ($s = 0; $s < count($mozEcName) ; $s++) {
        	$n[substr($mozEcName[$s],strlen($mozEcName[$s]) - 1)] = hexdec(substr($mozEcName[$s],0, strlen($mozEcName[$s]) - 1));
        }
        $z1 = ($t * $n[0] + $e * $n[2]) % 256;
        $z2 = ($t * $n[1] + $e * $n[3]) % 256;
        return array("z1"=>$z1,"z2"=>$z2);
    }
}
/**
* PHP 解码 JS代码 混淆类
*/
class JS
{

	public static function parse($url){
		$content = file_get_contents($url);
		preg_match('#}\(\'(.+?)\',(\d+),(\d+),\'(.+?)\'\.split\(\'\|\'\),\d+,\{\}\)#', $content,$hit);
		$code = str_replace("\\\\","\\",str_replace("\'","'",$hit[1]));
		$base = $hit[2];
		$size = $hit[3];
		$names = explode('|', $hit[4]);
		return self::decrypt($code,$base,$size,$names);
	}
	public static function decrypt($code,$base,$size,$names){
		$value = array();
		while ($size--) {
			if($names[$size]){
				$value[self::getkey($size,$base)] = $names[$size];
			}else if(self::getkey($size,$base)){
				$value[self::getkey($size,$base)] = self::getkey($size,$base);
			}
	    }
    	$regex = '/\\b\\w+\\b/';
    	$code = preg_replace_callback($regex, function($matches) use ($value) { $key = $matches[0];
			    	if(!empty($value[$key])){$name = $value[$key];}else{$name = $key;}return $name;},$code); 
	    return $code;
	}
	private static function getkey($size,$base) {
		return ($size < $base ? '' : self::getkey(intval($size / $base),$base)).(($size = $size % $base) > 35 ? chr($size + 29) : base_convert($size,10,36));
	}
}
?>