<?php
$video_info = Youku::parse($url);
echo json_encode($video_info);
/**
* 
*/
class Youku
{
	public static function parse($url)
	{
	    $content = self::curl($url);
	    preg_match('#videoId:"(.*?)", videoId2:"(.*?)",#',$content,$vids);
		$vid1 = $vids[1];
		$vid2 = $vids[2];
	    return self::get_video_url($vid2);
	}
	private static function get_video_url($vid){
		$content = self::get_tv_data($vid);
		$json = json_decode($content,true);
		$data = $json["data"];
		$stream = $data["stream"];
		$count = 0;
		foreach ($stream as $key => $value) {
			$stream_type = $value["stream_type"];
			if($stream_type=="mp4hd2"||$stream_type=="mp4hd3"||$stream_type=="3gphd"||$stream_type=="flvhd"){//过滤 
					continue;
			}
			switch ($stream_type) {
				case  "mp4sd":		$type = "mp4";$def = "MP4高清";		break;# 640x360
				case  "mp4hd2":		$type = "flv";$def = "FLV超高清";	break;# 1280x720
				case  "mp4hd3":		$type = "flv";$def = "FLV原画";		break;# 1920x1080
				case  "3gphd":		$type = "mp4";$def = "3GP高清";		break;# 640x360
				case  "flvhd":		$type = "flv";$def = "FLV高清";		break;# 640x360
				case  "mp4hd2v2":	$type = "mp4";$def = "MP4超高清";	break;# 1280x720
				case  "mp4hd":		$type = "mp4";$def = "MP4超清";		break;# 960x540
				case  "mp4hd3v2":	$type = "mp4";$def = "MP4原画";		break;# 1920x1080
				case  "mp5sd":		$type = "mp4";$def = "MP5高清";		break;# 640x360
				case  "mp5hd2":		$type = "mp4";$def = "MP5超高清";	break;# 1280x720
				case  "mp5hd3":		$type = "mp4";$def = "MP5原画";		break;# 1920x1080
				case  "mp5hd":		$type = "mp4";$def = "MP5超清";		break;# 960x540
			}
			$m3u8 = $value["m3u8_url"];//m3u8文件地址
			if (GlobalBase::is_ipad()) {
				if($stream_type=='mp4hd'){
					$videoinfo["video"]["file"] = $m3u8;
      				$videoinfo["video"]["type"] = "video/m3u8";
         			break;
				}
         	}else{
         		$video_m3u8[0] = $m3u8;
				$video_m3u8[1] = "video/m3u8";
				$video_m3u8[2] = $def;
				$video_m3u8[3] =  $stream_type != "mp4hd" ? 0 : 10;
				$videoinfo["video"][$count] = $video_m3u8;
         	}
         	$count++;
		}
		return $videoinfo;
	}
	public static function curl($url,$cookie="")
	{
    	$params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    	$params["cookie"] = $cookie;
      	return GlobalBase::curl($url,$params);
	}
	public static function get_h5_data($vid)
	{
		$ckey = urlencode("DIl58SLFxFNndSV1GFNnMQVYkx1PP5tKe1siZu/86PR1u/Wh1Ptd+WOZsHHWxysSfAOhNJpdVWsdVJNsfJ8Sxd8WKVvNfAS8aS8fAOzYARzPyPc3JvtnPHjTdKfESTdnuTW6ZPvk2pNDh4uFzotgdMEFkzQ5wZVXl2Pf1/Y6hLK0OnCNxBj3+nb0v72gZ6b0td+WOZsHHWxysSo/0y9D2K42SaB8Y/+aD2K42SaB8Y/+ahU+WOZsHcrxysooUeND");
		$ccode = "0502";//0502
		preg_match('#Etag="(.*)";#',file_get_contents("http://log.mmstat.com/eg.js"),$cna);
		$utid = urlencode($cna[1]);
		$client_ip = "192.168.1.1";
		$url = "https://ups.youku.com/ups/get.json?vid=$vid&ccode=$ccode&client_ip=$client_ip&utid=$utid&client_ts=".time()."&ckey=".$ckey;
		$content = self::curl($url,COOKIE_YOKU);
		return $content;
	}
	public static function get_data($vid)
	{
		$ckey = urlencode("7B19C0AB12633B22E7FE81271162026020570708D6CC189E4924503C49D243A0DE6CD84A766832C2C99898FC5ED31F3709BB3CDD82C96492E721BDD381735026");
		$ccode = "01010101";//01010203
		$utid = urlencode(Cna::utid());
		$client_ip = "192.168.1.1";
		$url = "https://ups.youku.com/ups/get.json?vid=$vid&ccode=$ccode&client_ip=$client_ip&utid=$utid&client_ts=".time()."&ckey=".$ckey;
		$content = self::curl($url,COOKIE_YOKU);
		return $content;
	}
	public static function get_tv_data($vid)
	{
		$ckey = urlencode("7B19C0AB12633B22E7FE81271162026020570708D6CC189E4924503C49D243A0DE6CD84A766832C2C99898FC5ED31F3709BB3CDD82C96492E721BDD381735026");
		$ccode = "0103010102";
		$utid = urlencode(Cna::utid());
		$client_ip = "192.168.1.1";
		$url = "https://ups.cp31.ott.cibntv.net/ups/get.json?vid=$vid&ccode=$ccode&client_ip=$client_ip&utid=$utid&h265=1&ptoken=&stoken=&atoken=&client_ts=".time()."&ckey=".$ckey;
		$content = self::curl($url,COOKIE_YOKU);
		return $content;
	}
}
/**
* 
*/
class Cna
{
	
	public static function get_signature($str)
	{
	    $signature = "";
	    $key="d6fc3a4a06adbde89223bvefedc24fecde188aaa9161";
	    if (function_exists('hash_hmac'))
	    {
	        $signature = base64_encode(hash_hmac("sha1", $str, $key, true));
	    }else{
	        $blocksize	= 64;
	        $hashfunc	= 'sha1';
	        if (strlen($key) > $blocksize){ $key = pack('H*', $hashfunc($key));}
	        $key	= str_pad($key,$blocksize,chr(0x00));
	        $ipad	= str_repeat(chr(0x36),$blocksize);
	        $opad	= str_repeat(chr(0x5c),$blocksize);
	        $hmac 	= pack('H*',$hashfunc(($key^$opad).pack('H*',$hashfunc(($key^$ipad).$str))));
	        $signature = base64_encode($hmac);
	    }
	    return $signature;
	}
	public static function utid()
	{
		$str = mt_rand(-2147483648,2147483648);
		$i = time();
		$j = mt_rand(-2147483648,2147483648);
		$arrayOfByte1 = self::aa($i);
		$arrayOfByte2 = self::aa($j);
		$arr = array_merge($arrayOfByte1,$arrayOfByte2);
		$arr[count($arr)]= 3;
		$arr[count($arr)]= 0;
		$arr = array_merge($arr,self::aa(self::ca($str)));
		$sign = self::get_signature(self::ba($arr));
		$arr = array_merge($arr,self::aa(self::ca($sign)));
		return base64_encode(self::ba($arr));
	}
	public static function  ca($paramString)
	{
		$i = 0;$k = 0;
		if (strlen($paramString) <= 0) {return $k;}
		$param = str_split($paramString);
		$arr = array();
		for ($n=0; $n < count($param); $n++) { 
			$arr[$n]= ord($param[$n]);
		}
		$j = 0;
		while (true) {
			$k = $i;
			if ($j >= count($arr)) {break;}
			$i = self::intval32($i * 31 + $arr[$j]);
			$j += 1;
		}
		return $k;
	}
	public static function aa($paramInt)
	{
		$i = $paramInt % 256;
		$j = ($paramInt >>= 8) % 256;
		$k = ($paramInt >>= 8) % 256;
		$n = ($paramInt >> 8) % 256;
		$arr =  array($n, $k, $j, $i);
		return $arr;
	}
	public static function ba($arr)
	{
		$str = "";
		for ($i=0; $i <count($arr) ; $i++) { 
			$str .= chr($arr[$i]);
		}
		return $str;
	}
	public static function intval32($num) {
		$num = $num & 0xffffffff;
		$p = $num>>31;
		if($p==1) {
			$num = $num-1;
			$num = ~$num;
			$num = $num & 0xffffffff;
			return $num * -1;
		} else {
			return $num;
		}
	} 
}
?>