<?php 

$ids = Sohu::parse($url);
if (GlobalBase::is_ipad()) {
  if($ids["drm"]){
     echo json_encode(GlobalBase::get_unknown_video());
  }else{
     echo json_encode(Sohu::get_video_phone_playinfo($ids["vid"]));
  }
}else{
  echo json_encode(Sohu::get_sub_video_url($ids));
}
/**
* http://m.film.sohu.com/album/video.json?aid=9313054&vid=4174005
* 
*http://s1.api.tv.itc.cn/v4/video/info/4174005.json?plat=6&poid=1&api_key=9854b2afa779e1a6bff1962447a09dbd&aid=9313054
*/
class Sohu
{
  public static function parse($url)
  {
      $content = self::curl($url);
      preg_match('#var vid="(.*?)"#',$content,$vids);
      preg_match('#var playlistId="(.*?)"#',$content,$plids);
      preg_match('#var videoIsFee = "(.*?)"#',$content,$videoIsFee);
    	$vid = $vids[1];
    	$pid = $plids[1];
      $drm = $videoIsFee[1];//是否付费
      $ids = array("vid"=>$vid,"pid"=>$pid,"drm"=>$drm);
      return $ids;
  }
  /**
   * [get_mkey 获取会员视频 mkey]
   * @param  [type] $ids [description]
   * @return [type]      [description]
   */
  public static function get_mkey($ids)
  {
      $time = number_format(microtime(true),3,'','');
      $vid = $ids["vid"];
      $aid = empty($ids["pid"]) ? "123456" : $ids["pid"];
      $api = "http://api.store.sohu.com/film/pc/checkpermission?aid={$aid}&vid={$vid}&passport=ppag82224eac4c7e@sohu.com&scuser=1&t={$time}";
      $content = self::curl($api,COOKIE_SOHU);
      $data = json_decode($content,true);
      if(isset($data["data"]["mkey"])){
        return "&mkey=".$data["data"]["mkey"];
      }else{
        return "";
      }
  }
	 #===============================================================================================================================
    #在链接的接口添加&ca=4&prod=h5&uid=15069517297961037536 此数据自己写  fuid:15069517297961037536  1704291352423486 
    #友情提示：UID参数需上报才能解决不限速播放
    /**
     * [get_sub_video_url 获取分段视频地址，组建列表文件]
     * @param  [type] $vid [description]
     * @return [type]      [description]
     */
    public static function get_sub_video_url($ids)
    {
        $vid = $ids["vid"];
        $uid = "1704291352423486";
        $mkey = $ids["drm"] ? self::get_mkey($ids) : "";
        $url = "http://hot.vrs.sohu.com/vrs_flash.action?vid={$vid}&uid={$uid}".$mkey;
        $content = file_get_contents($url);

        $body = json_decode($content,true);
        if($body['status']!=1){
          return "";
        }
        //=============================================================== 
        $video_infos = array();
        $videos = array();
        $allot = $body['allot'];//视频 host 分服务器
        $prot = $body['prot'];//视频分服务器端口
        $data = $body['data'];
        $totalDuration = $data['totalDuration'];//视频文件总时间
        $totalBytes = $data['totalBytes'];//视频文件总大小
        
       /* $video_json["poster"] = $data['coverImg'];//封面图片

        $preview = "http://".$_SERVER['HTTP_HOST']."/vip/preview.php?url=".$body['pvpic']['big'];
        $num = $totalDuration/1500;
        for ($i=0; $i <= $num; $i++) { 
          $p_file[$i] = $preview."&id=".($i+1);
        }
        $video_json["preview"] = array("file"=>$p_file,"scale"=>15); //视频预览图
        $eP = $data['eP'];
        if(!empty($eP)){
          foreach ($eP as $key => $value) {
            $video_json["promptSpot"][$key] = array("words"=>$value["v"],"time"=>$value["k"]);
          }
        }*/
        $su = $data['su'];
        $ck = $data['ck'];
        $clipsURL = $data['clipsURL'];
        $clipsBytes = $data['clipsBytes'];
        $clipsDuration = $data['clipsDuration'];
       
        foreach ($clipsURL as $key => $value) {   
          $url = $value;//$clipsURL[$key];
          $url = str_replace("http://data.vod.itc.cn","",$url);
          $bytes = $clipsBytes[$key];
          $duration = $clipsDuration[$key];
          $s_su = $su[$key];

          $vurl = "http://data.vod.itc.cn/?new={$s_su}&vid={$vid}&plat=17{$mkey}&user=api&uid={$uid}&prod=ad";
          $video["file"] = $vurl;     //分段视频地址
          $video["duration"] = $duration; //分段视频时间
          $video["bytesTotal"] = $bytes;  //分段视频文件大小
          $videos[$key] = $video;
      }
      $video_info["video"] = $videos;
      $video_info["type"] = "mp4";
      $video_info["weight"] = 10;
      $video_info["definition"] = "高清";
      $video_infos[count($video_infos)] = $video_info;
      $videoinfo["flashplayer"] = true;
      $videoinfo["video"] = $video_infos;
      self::get_report_urls($uid);//向服务器上报
      return $videoinfo;
    }
    public static function get_video_phone_playinfo($vid)
    {
      $uid = "1704291352423486";
      $time = number_format(microtime(true),3,'','');
      $api = "http://m.tv.sohu.com/phone_playinfo?vid={$vid}&site=1&appid=tv&api_key=f351515304020cad28c92f70f002261c&plat=17&sver=1.0&partner=1&uid={$uid}&muid=1508052529396230&_c=1&pt=5&qd=680&src=11060001&ssl=2&_={$time}";
      $content = file_get_contents($api);
      $content = mb_check_encoding($content,'gbk')?iconv('gbk','utf-8//IGNORE',$content):$content;//将字符串的编码从gbk转到UTF-8 
      $body = json_decode($content,true);
      $data = $body['data'];
      $title = $data['video_name'];//视频标题
      $urls = $data['urls'];//视频文件列表
      $vurl = $urls["downloadUrl"][0][0];
      $m3u8s = $urls["m3u8"];
      $m3u8 = $m3u8s["hig"][0];

     
      $videoinfo["video"]["file"] = $m3u8;
      $videoinfo["video"]["type"] = "video/m3u8";
      self::get_report_urls($uid);//向服务器上报
      return $videoinfo;
    }
    public static function get_report_urls($uid){
      $time = time();
      //$report_urls = "http://mb.hd.sohu.com.cn/mc.gif?uid={$uid}&url=1002&value=&memo=%7B%22status%22%3A%220%22%7D&passport=&mtype=12&ltype=0&cv=3.7.0&mos=3&mosv=10.0.15063.674&pro=1&mfo=To+Be+Filled+By+O.E.M.&mfov=To+Be+Filled+By+O.E.M.&webtype=wifi&vid=&time={$time}&type=&channelid=419&sim=0&playlistid=&catecode=&preid=&newuser=0&enterid=0&startid={$time}";
      //file_get_contents($report_urls,false,stream_context_create(array('http'=>array('method'=>'GET','timeout'=>3))));

      $report_urls = "https://z.m.tv.sohu.com/h5_cc.gif?t={$time}&uid={$uid}&position=ad_request_new&op=click&details=%7B%7D&nid=&url=http%3A%2F%2Ftv.sohu.com%2Fupload%2Fstatic%2Fshare%2Fshare_play.html%23_6457518_0_2_1&refer=&screen=1326x550&os=android&platform=android&passport=&vid=&pid=&channeled=1211010000&MTV_SRC=11050001";

      file_get_contents($report_urls,false,stream_context_create(array('http'=>array('method'=>'GET','timeout'=>3))));
   
      //$report_urls = "https://z.m.tv.sohu.com/pv.gif?url=https%253A%252F%252Fm.tv.sohu.com%252F20161027%252Fn471587159.shtml&refer=http%253A%252F%252Ftv.sohu.com%252F20161027%252Fn471587159.shtml&uid=1704291352423486&webtype=2g&screen=1326x550&catecode=101112%3B101124&pid=9174927&vid=3349737&tvid=85617187&site=1&os=android&platform=android&passport=957099461778374656%40sohu.com&t=1517025723446&channeled=1211010000&oth=&cd=&isplay=1&MTV_SRC=11060001&sd=";
     
      //$report_urls = "https://z.m.tv.sohu.com/h5_cc.gif?t=1517025729747&uid=1704291352423486&position=play_verify1&op=click&details=%7B%7D&nid=&url=https%253A%252F%252Fm.tv.sohu.com%252F20161027%252Fn471587159.shtml&refer=http%253A%252F%252Ftv.sohu.com%252F20161027%252Fn471587159.shtml&screen=1326x550&os=android&platform=android&passport=957099461778374656%40sohu.com&vid=3349737&pid=9174927&channeled=1211010000&MTV_SRC=11060001";
    
      //$report_urls = "https://z.m.tv.sohu.com/h5_cc.gif?t=1517025798548&uid=1704291352423486&position=play_videopause&op=click&details=%7B%7D&nid=&url=https%253A%252F%252Fm.tv.sohu.com%252F20161027%252Fn471587159.shtml&refer=http%253A%252F%252Ftv.sohu.com%252F20161027%252Fn471587159.shtml&screen=1326x550&os=android&platform=android&passport=957099461778374656%40sohu.com&vid=3349737&pid=9174927&channeled=1211010000&MTV_SRC=11060001";

    }
    public static function curl($url,$cookie="")
    {
      //$data = mb_check_encoding($data,'gbk')?iconv('gbk','utf-8//IGNORE',$data):$data;//将字符串的编码从gbk转到UTF-8 
        $params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
        $params["cookie"] = $cookie;
        return GlobalBase::curl($url,$params);
    }
}
?>