<?php
  echo json_encode(AcFun::parse($url));
/**
* 
*/
class AcFun
{
	public static function parse($url)
	{
	  $content = self::curl($url);
	  preg_match('#"videoId":(\d+),#',$content,$vids);
	  $vid = $vids[1];
	  return self::get_video($vid);
	}
	public static function get_video($id){
		$url = "http://www.acfun.cn/video/getVideo.aspx?id={$id}";
		$content = self::curl($url,COOKIE_ACFUN);
		$data = json_decode($content,true);
		$vid = $data["sourceId"];
		$sign = $data["encode"];
		return self::get_video_url($vid,$sign);
	}
	public static function get_video_url($vid,$sign){
		$time = number_format(microtime(true),3,'','');
		$api = "http://player.acfun.cn/flash_data?vid={$vid}&ct=85&ev=3&sign={$sign}&time={$time}";
		$content = self::curl($api,COOKIE_ACFUN);
		$data = json_decode($content,true)["data"];
		$json = json_decode(self::rc4(base64_decode($data)),true);
		$stream = $json["stream"];
		$host = GlobalBase::is_https().$_SERVER["HTTP_HOST"];
		$videos = array();
		foreach ($stream as $key => $value) {
			$stream_type = $value["stream_type"];
			/*if($stream_type=='flvhd'||$stream_type=='mp4hd'||$stream_type=='mp4hd2'||$stream_type=='mp4hd3'){
				switch ($stream_type) {
					case 'flvhd':$def = "MP4高清";break;//640x360
					case 'mp4hd':$def = "MP4超清";break;//960x540
					case 'mp4hd2':$def = "720P";  break;//1280x720
					case 'mp4hd3':$def = "1080P"; break;//1920x1080
				}
				$segs = $value["segs"];
				$vurl = $segs[0]["url"];
	         	break;
			}*/
			if($stream_type=='m3u8_mp4'){//$stream_type=='m3u8_flv'||$stream_type=='m3u8_hd'
				switch ($stream_type) {
					//case 'm3u8_flv':$def = "高清";break;//640x360
					case 'm3u8_mp4':$def = "超清";break;//960x540
					case 'm3u8_hd':$def = "超高清";  break;//1280x720
				}
				if (!GlobalBase::is_ipad()) {
					$videoinfo["flashplayer"] = true;
				}
				$m3u8 = $value["m3u8"];
				$videoinfo["video"]["file"] = $host."/video/m3u8.php?url=".base64_encode($m3u8)."&site=acfun";
				$videoinfo["video"]["type"] = "video/m3u8";
			
			}
	     	
		}
		return $videoinfo;
	}
	public static function curl($url,$cookie="")
	{
    	$params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    	$params["cookie"] = $cookie;
      	return GlobalBase::curl($url,$params);
	}
	/**
	 * rc4(base64_decode($data),'8bdc7e1a');
	 * acfun 算法
	 *
	 */
	public static function rc4($data,$pwd="8bdc7e1a"){
	    $key[] = '';
	    $box[] = '';
	    $cipher= '';
	    $pwd_length = strlen($pwd);
	    $data_length = strlen($data);
	    for ($i = 0; $i < 256; $i++){
	        $key[$i] = ord($pwd[$i % $pwd_length]);
	        $box[$i] = $i;
	    }
	    for ($j = $i = 0; $i < 256; $i++){
	        $j = ($j + $box[$i] + $key[$i]) % 256;
	        $tmp = $box[$i];
	        $box[$i] = $box[$j];
	        $box[$j] = $tmp;
	    }
	    for ($a = $j = $i = 0; $i < $data_length; $i++){
	        $a = ($a + 1) % 256;
	        $j = ($j + $box[$a]) % 256;
	        $tmp = $box[$a];
	        $box[$a] = $box[$j];
	        $box[$j] = $tmp;
	        $k = $box[(($box[$a] + $box[$j]) % 256)];
	        $cipher .= chr(ord($data[$i]) ^ $k);
	    }
	    return $cipher;
	}
	public static function get_embsig($vid,$time){
	    $sign = $vid.'_'.$time.'_'.'a413bf8e1ac536a36203a01adbddd272';
	    return '1'.'_'.$time.'_'.md5($sign);
	}
}
 ?>