<?php 
//http://baseapi.busi.inke.cn/live/LiveInfo?channel_id=&uid=19063747&liveid=&_t=1515529532339
//http://webapi.busi.inke.cn/web/live_share_pc?uid=19063747&id=1515529324171098
//
//require_once("../include/global.inc.php");
//$url = "http://www.inke.cn/live.html?uid=12435143&id=1515530199767742";
//$url = "http://h5.inke.cn/app/hot/live?uid=12435143";

echo json_encode(InKe::parse($url));

/**
* 
*/
class InKe
{
	
	public static function parse($url)
    {
    	parse_str(parse_url($url)["query"]);
    	if($uid){
            $data = self::get_live_url($uid);
            if(empty($data)){
                $data = self::get_video_url($uid);
            }
            return $data;
    	}
    }
    public static function get_live_url($uid)
    {
    	$api = "http://baseapi.busi.inke.cn/live/LiveInfo?uid={$uid}";
        $content = self::curl($api);
     	$json = json_decode($content,true);
        $data = $json["data"];
        if(!empty($data["live_addr"])){
        	$image = $data["live_info"]["image"];
        	$videoinfo["poster"] = $image;
        	$live_addr = $data["live_addr"][0];
			$flv = $live_addr["stream_addr"];
			$m3u8 = $live_addr["hls_stream_addr"];
			$rtmp = $live_addr["rtmp_stream_addr"];
			if (GlobalBase::is_ipad()) {
				$videoinfo["video"]["file"] = $m3u8;
                $videoinfo["video"]["type"] = "video/m3u8";
	     	}else{
	     		$videoinfo["live"] = true;
                $videoinfo["flashplayer"] = true;
	     		$video = array($flv,"flv","FLV高清",0);
				$videoinfo["video"][0] = $video;
				$video = array($m3u8,"m3u8","m3u8高清",10);
				$videoinfo["video"][1] = $video;
				$video = array($rtmp,"rtmp","rtmp高清",0);
				$videoinfo["video"][2] = $video;
	     	}
            return $videoinfo;
        }else{
            return null;
        }
        
    }
    public static function get_video_url($uid)
    {
        $api = "http://webapi.busi.inke.cn/web/live_share_pc?uid={$uid}&id=1";
        $content = self::curl($api);
        $json = json_decode($content,true);
        if(!empty($json["data"])){
            $data = $json["data"];
            $videoinfo["poster"] = $data["file"]["img"];
            $m3u8 = $data["file"]["record_url"];
            $videoinfo["video"]["file"] = $m3u8;
            $videoinfo["video"]["type"] = "video/m3u8";
            return $videoinfo;
        }
    }
    public static function curl($url)
    {
        $params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
        return GlobalBase::curl($url,$params);
    }
}
 ?>